<template>
  <div v-if="internalMessages.length">
    <!-- The `model-value` check ensures there is a message body with the correct locale in order to show the banner -->
    <b-alert
      v-for="(message, index) in internalMessages"
      :key="index"
      :model-value="message.body?.[locale] !== undefined"
      show
      dismissible
      :locale="$i18n.locale"
      :variant="getBannerVariant(message.type)"
      @closed="hideMessage(message.id)"
    >
      <p v-dompurify-html="renderMarkdown(message.body?.[locale] || '~')" />
    </b-alert>
  </div>
</template>

<script lang="ts">
import { defineComponent, computed } from "vue";
import { useI18n } from "vue-i18n";
import { useSystemStatusStore } from "@/store/systemStatus";
import { mapMessageTypeToBannerVariant } from "@/util/messageTypeMap";
import type { MessageType } from "@coscine/api-client/dist/types/Coscine.Api";
import type { BaseColorVariant } from "bootstrap-vue-next/dist/src/types";
import markdownIt from "markdown-it";

export default defineComponent({
  setup() {
    const i18n = useI18n();
    const systemStatusStore = useSystemStatusStore();

    const md = markdownIt();

    const locale = computed(() => i18n.locale.value);

    /**
     * Computes the list of visible internal messages from the system status store.
     * @returns {MessageDto[]} The list of visible internal messages.
     */
    const internalMessages = computed(
      () => systemStatusStore.visibleInternalMessages,
    );

    /**
     * Hides a message by its ID.
     * @param {string | undefined} id - The ID of the message to hide.
     */
    const hideMessage = (id?: string) => {
      if (id) systemStatusStore.hideMessage(id);
    };

    /**
     * Maps a message type to a Bootstrap Vue variant.
     * @param {MessageType | undefined} type - The type of the message.
     * @returns {keyof BaseColorVariant | null | undefined} The corresponding Bootstrap Vue variant.
     */
    const getBannerVariant = (
      type?: MessageType,
    ): keyof BaseColorVariant | null | undefined => {
      return mapMessageTypeToBannerVariant(type);
    };

    /**
     * Renders markdown to HTML.
     * @param {string} markdownText - The markdown text to render.
     * @returns {string} The rendered HTML.
     */
    const renderMarkdown = (markdownText: string): string => {
      return md.render(markdownText);
    };

    return {
      internalMessages,
      locale,
      hideMessage,
      getBannerVariant,
      renderMarkdown,
    };
  },
});
</script>
